## ros-noetic-usb-cam 0.3.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(usb_cam)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS image_transport roscpp std_msgs std_srvs sensor_msgs camera_info_manager)

## pkg-config libraries
find_package(PkgConfig REQUIRED)
pkg_check_modules(avcodec libavcodec REQUIRED)
pkg_check_modules(swscale libswscale REQUIRED)

###################################################
## Declare things to be passed to other projects ##
###################################################

## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

###########
## Build ##
###########

include_directories(include
  ${catkin_INCLUDE_DIRS}
  ${avcodec_INCLUDE_DIRS}
  ${swscale_INCLUDE_DIRS}
)

## Build the USB camera library
add_library(${PROJECT_NAME} src/usb_cam.cpp)
target_link_libraries(${PROJECT_NAME}
  ${avcodec_LIBRARIES}
  ${swscale_LIBRARIES}
  ${catkin_LIBRARIES}
)

## Declare a cpp executable
add_executable(${PROJECT_NAME}_node nodes/usb_cam_node.cpp)
target_link_libraries(${PROJECT_NAME}_node
  ${PROJECT_NAME}
  ${avcodec_LIBRARIES}
  ${swscale_LIBRARIES}
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}_node ${PROJECT_NAME}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

## Copy launch files
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch"
)

install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

=== debian/changelog ===
ros-noetic-usb-cam (0.3.6-1buster) buster; urgency=high

  * .travis.yml: udpate to trusty
  * add AV_ prefix to PIX_FMT_* for X,Y (#71 <https://github.com/ros-drivers/usb_cam/issues/71>)
  * Contributors: Kei Okada

 -- Russell Toris <rctoris@wpi.edu>  Wed, 14 Jun 2017 15:00:00 -0000

ros-noetic-usb-cam (0.3.5-1buster) buster; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#69 <https://github.com/ros-drivers/usb_cam/issues/69>)
  * support for Kinetic / Ubuntu 16.04 (#58 <https://github.com/ros-drivers/usb_cam/issues/58>)
    * replace use of deprecated functions in newer ffmpeg/libav versionsffmpeg/libav 55.x (used in ROS Kinetic) deprecated the avcodec_alloc_frame.
  * Add grey scale pixel format. (#45 <https://github.com/ros-drivers/usb_cam/issues/45>)
  * add start/stop capture services (#44 <https://github.com/ros-drivers/usb_cam/issues/44> )
    * better management of start/stop
    * up package.xml
    * add capture service
  * fix bug for byte count in a pixel (3 bytes not 24 bytes) (#40 <https://github.com/ros-drivers/usb_cam/issues/40> )
  * Contributors: Daniel Seifert, Eric Zavesky, Kei Okada, Ludovico Russo, Russell Toris, honeytrap15

 -- Russell Toris <rctoris@wpi.edu>  Tue, 13 Jun 2017 15:00:00 -0000

ros-noetic-usb-cam (0.3.4-1buster) buster; urgency=high

  * Installs launch files
  * Merge pull request #37 from tzutalin/develop
    Add a launch file for easy test
  * Add a launch file for easy test
  * Contributors: Russell Toris, tzu.ta.lin

 -- Russell Toris <rctoris@wpi.edu>  Mon, 17 Aug 2015 15:00:00 -0000

ros-noetic-usb-cam (0.3.3-1buster) buster; urgency=high

  * Merge pull request #36 from jsarrett/develop
    add gain parameter
  * add gain parameter
  * Contributors: James Sarrett, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Wed, 13 May 2015 15:00:00 -0000

ros-noetic-usb-cam (0.3.2-1buster) buster; urgency=high

  * Merge pull request #34 from eliasm/develop
    fixed check whether calibration file exists
  * fixed check whether calibration file exists
  * Contributors: Elias Mueggler, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Mon, 23 Mar 2015 15:00:00 -0000

ros-noetic-usb-cam (0.3.1-1buster) buster; urgency=high

  * Merge pull request #32 from kmhallen/mono8
    Publish YUVMONO10 images as mono8 instead of rgb8
  * Publish YUVMONO10 images as mono8 instead of rgb8
  * Contributors: Kevin Hallenbeck, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 19 Feb 2015 15:00:00 -0000

ros-noetic-usb-cam (0.3.0-1buster) buster; urgency=high

  * Merge pull request #30 from mitchellwills/develop
    Removed global state from usb_cam by encapsulating it inside an object
  * Made device name a std::string instead of const char*
  * Added usb_cam namespace
  * Added underscore sufix to class fields
  * Removed camera_ prefix from methods
  * Moved methods to parse pixel_format and io_method from string to UsbCam
  * Moved camera_image_t struct to be private in UsbCam
  * Cleaned up parameter assignment
  * Made set_v4l_parameters a non-static function
  * Moved set_v4l_parameters to UsbCam object
  * Removed global state from usb_cam by encapsulating it inside an object
    function and structions in usb_cam.h became public and everything else is private
  * Merge pull request #28 from mitchellwills/develop
    Fix installation of header files
  * Fix installation of header files
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Sun, 25 Jan 2015 15:00:00 -0000

ros-noetic-usb-cam (0.2.0-1buster) buster; urgency=high

  * Bug fix in camera info settings.
  * Update .travis.yml
  * Merge pull request #27 from bosch-ros-pkg/default_camera_info
    sets default camera info
  * sets default camera info
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 15 Jan 2015 15:00:00 -0000

ros-noetic-usb-cam (0.1.13-1buster) buster; urgency=high

  * Merge pull request #25 from blutack/patch-1
    Warn rather than error if framerate can't be set
  * Warn rather than error if framerate can't be set
    The driver doesn't currently work with em28xx based devices as they don't allow the framerate to be set directly and the node exits with an error. Changing to a warning allows these devices to be used.
  * Update README.md
  * Merge pull request #24 from rjw57/do-not-touch-parameters-unless-asked
    do not modify parameters unless explicitly set
  * do not modify parameters unless explicitly set
    The contrast, saturation, brightness, sharpness and focus parameters
    were recently added to usb_cam. This caused a regression
    (sigproc/robotic_surgery#17) whereby the default settings for a webcam
    are overridden in all cases by the hard-coded defaults in usb_cam.
    In the absence of a know good set of "default" values, leave the
    parameters unset unless the user has explicitly set them in the launch
    file.
  * Contributors: Rich Wareham, Russell Toris, blutack

 -- Russell Toris <rctoris@wpi.edu>  Mon, 01 Dec 2014 15:00:00 -0000

ros-noetic-usb-cam (0.1.12-1buster) buster; urgency=high

  * Merge pull request #22 from dekent/develop
    White balance parameters
  * Parameter to enable/disable auto white balance
  * Added parameters for white balance
  * uses version major to check for av_codec
  * uses version header to check for AV_CODEC_ID_MJPEG
  * Contributors: David Kent, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Tue, 04 Nov 2014 15:00:00 -0000

ros-noetic-usb-cam (0.1.11-1buster) buster; urgency=high

  * Merge pull request #20 from dekent/develop
    More Parameters
  * bug fix
  * Setting focus when autofocus is disabled
  * Parameter adjusting
  * Added parameter setting for absolute focus, brightness, contrast, saturation, and sharpness
  * Contributors: David Kent, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Wed, 29 Oct 2014 15:00:00 -0000

ros-noetic-usb-cam (0.1.10-1buster) buster; urgency=high



=== debian/control ===
Source: ros-noetic-usb-cam
Section: misc
Priority: optional
Maintainer: Russell Toris <rctoris@wpi.edu>
Build-Depends: debhelper (>= 9.0.0), ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Homepage: http://wiki.ros.org/usb_cam
Standards-Version: 3.9.2

Package: ros-noetic-usb-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-camera-info-manager, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, v4l-utils
Description: A ROS Driver for V4L USB Cameras

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-usb-cam//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-usb-cam 0.3.7

=== debian/changelog ===
ros-noetic-usb-cam (0.3.7-1focal) focal; urgency=high

  * Merge pull request #234 <https://github.com/ros-drivers/usb_cam/issues/234> from knorth55/add-maintainer
    Add Shingo Kitagawa as maintainer
  * add shingo kitagawa as maintainer
  * Merge pull request #233 <https://github.com/ros-drivers/usb_cam/issues/233> from knorth55/fix-memory-leak
    fix memory leak in usb_cam.cpp
  * fix memory leak in usb_cam.cpp
  * Merge pull request #229 <https://github.com/ros-drivers/usb_cam/issues/229> from knorth55/update-readme
    update readme
  * update readme
    update budges
    format md
    add ros2 branch info
  * Merge pull request #227 <https://github.com/ros-drivers/usb_cam/issues/227> from knorth55/develop-ci
    Adds CI protocols
  * Merge pull request #228 <https://github.com/ros-drivers/usb_cam/issues/228> from knorth55/fix-typo
    not use LINK libraries
  * change workflows name
  * change workflows name
  * not use LINK libraries
  * add github actions
  * add github actions
  * AUTHORS.md - typo fix
  * Added contributors information
  * Workaround for CMake deprecation warning
  * Fixed library names for pkg-config
    - Fixed library names in the pkg-config section of CMakeLists.txt
    - Closes #202 <https://github.com/ros-drivers/usb_cam/issues/202>
  * Added maintainer address
  * Added maintainer address
  * Added proper CMake OpenCV package handler
  * Merge pull request #126 <https://github.com/ros-drivers/usb_cam/issues/126> from benmaidel/feature/unsupported_set_format_options
    allow cameras that do not support setting format options via VIDIOC_S_FMT
  * Added support for BGR24 pixel format
    - Added support for OpenCV BRG24 pixel format
    (supported by Raspberry Pi camera V4L2 kernel drivers)
    Solution by @romainreignier manually merged by @twdragon
    - Untested. Merged in favour of the tests made by @flynneva
    - Closes #97 <https://github.com/ros-drivers/usb_cam/issues/97>
  * Deprecation message workaround for native H.264
    - Added MJPEG pixel format deprecation reset
    (solution by @at-wat)
    - Added native H.264 pixel format deprecation
    workaround.
    TODO: Find a way to start H.264 decoding from the keyframe
    - Added frame parser context for future development
    - Removed possible memory leak in context allocation
    (all libav contexts and packets are now released properly)
    - Closes #72 <https://github.com/ros-drivers/usb_cam/issues/72>
  * Merge branch 'develop' of github.com:ros-drivers/usb_cam into develop
  * Merge pull request #110 <https://github.com/ros-drivers/usb_cam/issues/110> from rmukhia/develop
    Add support for cameras with hardware 'h264' encoding.
  * Merge branch 'develop-h264' into develop
  * Cosmetic fix for old repository URLS
  * Merge branch 'develop' into develop
  * Merge pull request #115 <https://github.com/ros-drivers/usb_cam/issues/115> from lukehutch/develop
    Suppress libav "deprecated pixel format used" mjpeg warnings
  * Merge pull request #125 <https://github.com/ros-drivers/usb_cam/issues/125> from benmaidel/feature/YUV420
    add support for YUV420 (yu12) pixel format
  * Merge pull request #197 <https://github.com/ros-drivers/usb_cam/issues/197> from twdragon/develop
    Full support for last FFMPEG
  * Name mismatch fix
  * Full support for last FFMPEG release
    - Removed deprecated AVPicture API calls
    - Implemented correct instantiation for
    AVFrame structures
    - Minor build fixes
  * Merge branch 'ros-drivers:develop' into develop
  * allow cameras that do not support setting format options via VIDIOC_S_FMT
  * add support for YUV420 (yu12) pixel format
  * Merge pull request #124 <https://github.com/ros-drivers/usb_cam/issues/124> from k-okada/add_noetic
    add noetic .travis.yml
  * add noetic .travis.yml
  * Suppress libav "deprecated pixel format used" mjpeg warnings
  * Updated sample launch file. h264 supported in 'pixel_format' params. A new parameter 'color_format' supports 'yuv422p' and 'yuv420p'
  * Enable h264 encoding to work with cams which supports hardware h264 encoding like Mobius Maxi.
  * Contributors: Andrei Vukolov, Andrey Vukolov, Benjamin Maidel, Evan Flynn, Kei Okada, Luke Hutchison, Raunak Mukhia, Shingo Kitagawa

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 02 Mar 2023 15:00:00 -0000

ros-noetic-usb-cam (0.3.6-1focal) focal; urgency=high

  * .travis.yml: udpate to trusty
  * add AV_ prefix to PIX_FMT_* for X,Y (#71 <https://github.com/ros-drivers/usb_cam/issues/71>)
  * Contributors: Kei Okada

 -- Russell Toris <rctoris@wpi.edu>  Wed, 14 Jun 2017 15:00:00 -0000

ros-noetic-usb-cam (0.3.5-1focal) focal; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#69 <https://github.com/ros-drivers/usb_cam/issues/69>)
  * support for Kinetic / Ubuntu 16.04 (#58 <https://github.com/ros-drivers/usb_cam/issues/58>)
    * replace use of deprecated functions in newer ffmpeg/libav versionsffmpeg/libav 55.x (used in ROS Kinetic) deprecated the avcodec_alloc_frame.
  * Add grey scale pixel format. (#45 <https://github.com/ros-drivers/usb_cam/issues/45>)
  * add start/stop capture services (#44 <https://github.com/ros-drivers/usb_cam/issues/44> )
    * better management of start/stop
    * up package.xml
    * add capture service
  * fix bug for byte count in a pixel (3 bytes not 24 bytes) (#40 <https://github.com/ros-drivers/usb_cam/issues/40> )
  * Contributors: Daniel Seifert, Eric Zavesky, Kei Okada, Ludovico Russo, Russell Toris, honeytrap15

 -- Russell Toris <rctoris@wpi.edu>  Tue, 13 Jun 2017 15:00:00 -0000

ros-noetic-usb-cam (0.3.4-1focal) focal; urgency=high

  * Installs launch files
  * Merge pull request #37 from tzutalin/develop
    Add a launch file for easy test
  * Add a launch file for easy test
  * Contributors: Russell Toris, tzu.ta.lin

 -- Russell Toris <rctoris@wpi.edu>  Mon, 17 Aug 2015 15:00:00 -0000

ros-noetic-usb-cam (0.3.3-1focal) focal; urgency=high



=== debian/control ===
Source: ros-noetic-usb-cam
Section: misc
Priority: optional
Maintainer: Andrey Vukolov <andrey.vukolov@elettra.eu>
Build-Depends: debhelper (>= 9.0.0), ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-cv-bridge, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Homepage: http://wiki.ros.org/usb_cam
Standards-Version: 3.9.2

Package: ros-noetic-usb-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-camera-info-manager, ros-noetic-cv-bridge, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, v4l-utils
Description: A ROS Driver for V4L USB Cameras
